import type { Ref } from 'vue';
import { GraphqlMiddlewareState } from './../../types';
import type { GraphqlMiddlewareQuery, GraphqlMiddlewareMutation } from '#build/nuxt-graphql-middleware';
declare type GraphqlMiddlewareQueryName = keyof GraphqlMiddlewareQuery;
declare type GraphqlMiddlewareMutationName = keyof GraphqlMiddlewareMutation;
declare type GraphqlMiddlewareOperationMap = GraphqlMiddlewareQuery | GraphqlMiddlewareMutation;
declare type GetArgs<T extends GraphqlMiddlewareQueryName, M extends GraphqlMiddlewareOperationMap> = M[T][0] extends null ? [T] : M[T][1] extends false ? [T, M[T][0]] : [T, M[T][0]?];
declare type GraphqlResponse<T> = {
    data: T;
};
declare type GetResult<T, M> = M[T] extends undefined ? undefined : GraphqlResponse<M[T][2]>;
export declare const useGraphqlState: () => Ref<GraphqlMiddlewareState>;
export declare function useGraphqlQuery<T extends GraphqlMiddlewareQueryName>(...args: GetArgs<T, GraphqlMiddlewareQuery>): Promise<GetResult<T, GraphqlMiddlewareQuery>>;
export declare function useGraphqlMutation<T extends GraphqlMiddlewareMutationName>(...args: GetArgs<T, GraphqlMiddlewareMutation>): Promise<GetResult<T, GraphqlMiddlewareMutation>>;
export {};
